//---------------------------------------------------------------------------
/*
	TJS2 Script Engine( Byte Code )
	Copyright (c), Takenori Imoto

	See details of license at "license.txt"
*/
//---------------------------------------------------------------------------

#ifndef tjsConstArrayDataH
#define tjsConstArrayDataH

#include "tjsTypes.h"
#include <vector>
#include "tjsVariant.h"
#include "tjsScriptBlock.h"
#include <map>
#include <string>

namespace TJS
{
/**
 * TJS2 oCgR[ho Variant ^𕪗AŗL^ŕێ邽߂̃NX
 */
class tjsConstArrayData {
private:
	std::vector<tjs_int8> Byte;
	std::vector<tjs_int16> Short;
	std::vector<tjs_int32> Integer;
	std::vector<tjs_int64> Long;
	std::vector<double> Double;
	std::vector<std::wstring> String;
	std::vector<std::vector<tjs_uint8>* > ByteBuffer;

	// ێǂ肷邽߂̃nbV
	std::map<tjs_int8,int> ByteHash;
	std::map<tjs_int16,int> ShortHash;
	std::map<tjs_int32,int> IntegerHash;
	std::map<tjs_int64,int> LongHash;
	std::map<double,int> DoubleHash;
	std::map<std::wstring,int> StringHash;
	// INebg^̎̓nbVgĂȂ

	static const tjs_uint8 TYPE_VOID = 0;
	static const tjs_uint8 TYPE_OBJECT = 1;
	static const tjs_uint8 TYPE_INTER_OBJECT = 2;
	static const tjs_uint8 TYPE_STRING = 3;
	static const tjs_uint8 TYPE_OCTET = 4;
	static const tjs_uint8 TYPE_REAL = 5;
	static const tjs_uint8 TYPE_BYTE = 6;
	static const tjs_uint8 TYPE_SHORT = 7;
	static const tjs_uint8 TYPE_INTEGER = 8;
	static const tjs_uint8 TYPE_LONG = 9;
	static const tjs_uint8 TYPE_UNKNOWN = -1;

	/**
	 * INebg^̒li[
	 */
	int PutByteBuffer( tTJSVariantOctet* val );

	/**
	 * 1oCg̒li[
	 */
	int PutByte( tjs_int8 b );
	
	/**
	 * 2oCg̒li[
	 */
	int PutShort( tjs_int16 b );
	
	/**
	 * 4oCg̒li[
	 */
	int PutInteger( tjs_int32 b );
	
	/**
	 * 8oCg̒li[
	 */
	int PutLong( tjs_int64 b );
	
	/**
	 * _li[
	 */
	int PutDouble( double b );

	static inline void Add8ByteToVector( std::vector<tjs_uint8>* array, tjs_int64 value ) {
		array->push_back( (tjs_uint8)((value>>0)&0xff) );
		array->push_back( (tjs_uint8)((value>>8)&0xff) );
		array->push_back( (tjs_uint8)((value>>16)&0xff) );
		array->push_back( (tjs_uint8)((value>>24)&0xff) );
		array->push_back( (tjs_uint8)((value>>32)&0xff) );
		array->push_back( (tjs_uint8)((value>>40)&0xff) );
		array->push_back( (tjs_uint8)((value>>48)&0xff) );
		array->push_back( (tjs_uint8)((value>>56)&0xff) );
	}
	static inline void Add4ByteToVector( std::vector<tjs_uint8>* array, int value ) {
		array->push_back( (tjs_uint8)((value>>0)&0xff) );
		array->push_back( (tjs_uint8)((value>>8)&0xff) );
		array->push_back( (tjs_uint8)((value>>16)&0xff) );
		array->push_back( (tjs_uint8)((value>>24)&0xff) );
	}
	static inline void Add2ByteToVector( std::vector<tjs_uint8>* array, tjs_int16 value ) {
		array->push_back( (tjs_uint8)((value>>0)&0xff) );
		array->push_back( (tjs_uint8)((value>>8)&0xff) );
	}
public:
	tjsConstArrayData() {}
	~tjsConstArrayData();

	/**
	 * i[
	 */
	int PutString( const tjs_char* val );

	/**
	 * oCAg^i[Ă^𓾂
	 */
	int GetType( tTJSVariant& v, tTJSScriptBlock* block );

	/**
	 * oCAgli[
	 */
	int PutVariant( tTJSVariant& v, tTJSScriptBlock* block );

	/**
	 * ێĂloCgɂĎo
	 */
	std::vector<tjs_uint8>* ExportBuffer();
};

} // namespace
#endif // tjsConstArrayDataH

